<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="../CSS and JS\style.css">
    <link rel="stylesheet" href="../CSS and JS\prism.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <title>Map</title>
</head>

<body>
    <h1>Map</h1>
    <a href="https://en.cppreference.com/w/cpp/container/map">For mer info klikk her.</a>
    <p>
        Map fungerer på mange måter likt som et "dictionary" i Python.
        Formålet med et map er å koble to verdier sammen.
        En kobling i et map deles inn i key (nøkkel) og value (verdi).
    </p>

    <h2>Opprette map</h2>
    <p>
        I eksempelet under oprettes et map som kobler sammen matvarer (key) med prisen på varen (value).
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Headerfil (foodPriceMap.hpp)

#pragma once
#include &ltmap>
#include &ltstring>
const std::map&ltstd::string, int> foodPriceMap {
    {"Milk", 10},
    {"Bread", 15}, 
    {"Salmon", 20},
};
</code>
	</pre>

    <h2>Hente og endre map</h2>
    <p>
        For å hente ut verdien kan man bruke medlemsfunksjonen at().
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Hovedfil (main.cpp)

#include &ltiostream>
#include "foodPriceMap.hpp"
int main()
{	
    std::cout << "The price of the milk is " << foodPriceMap.at("Milk") << "kr." << std::endl;
}
</code>
	</pre>
    </p>
    <p>
        For å legge til et element brukes medlemsfunksjonen insert().
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
foodPriceMap.insert({"Potet", 25}); // Legger til potet med pris 25
</code>
	</pre>
    <h2>iterere gjennom map</h2>
    <p>
        For å iterere gjennom map-et kan man bruke en for-løkke slik:
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
for (const auto& [key, value] : foodPriceMap) {
    std::cout << key << ":\t" << value << std::endl;
}
</code>
	</pre>

    <h2>Fjerne et element</h2>
    <p>
        For å fjerne et element kan man bruke medlemsfunksjonen erase().
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
foodPriceMap.erase("Milk");
</code>
	</pre>
    <h2>[] operatoren</h2>
    <p>
        Lik som vector har map en [] operator. Det frarådes å bruke denne, fordi den alltid oppretter verdien som blir
        etterspurt i map, selv om den ikke finnes, og det er egentlig ikke er meningen at den skal eksistere. I følgende
        eksempelet finnes det ikke en verdi som heter "Pepperkaker" i foodPriceMap, som [] operatoren da oppretter. Da
        brukes standardverdien 0, som gjør sammenligningen sant. Vi derfor anbefaler det alltid brukes at() og insert()
        i stede for [] operatoren.
    </p>
    <pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
if(foodPriceMap["Pepperkaker"] == 0) {

}
</code>
	</pre>

    <h2>Andre nyttige medlemsfunksjoner</h2>
    <p>
        Det finnes mange andre nyttige medlemsfunksjoner som:
    <ul>
        <li>empty</li>
        <li>size</li>
        <li>clear</li>
    </ul>
    <a href="https://en.cppreference.com/w/cpp/container/map">Klikk her for å lese mer om dem og annet om map.</a>
    </p>

    <script src="../CSS and JS\prism.js"></script>
    <script src="../CSS and JS/copy.js"></script>
</body>

</html>